-- FAMEGRAPHSTABLES.PRO
-- For use with the FPAS system for small country models


--**********************************************************************
procedure $leveltable
argument db,sdate,ehist,edate,picname,shockname

try
 close all
end try
reset
plot #1 color blue
plot #2 color red
plot #3 color black
abort on
show vertical
length full
ignore on
over on
deci auto
object precision
freq q

open <acc r> countrynames as cn
open <acc r> db as c
freq q

image date daily "<m>/<d>/<year>" 
scalar work'dbname1: string=upper(ltrim(mirror(substring(mirror(filespec(c)),4,location(mirror(filespec(c)),"\"))),"\"))
scalar work'dbdate1: string=datefmt(dbupdated(c))
date sdate to edate
page division colu 1, rows 1

series work'drawline by case
work'dct=1
work'cct=0
loop for p=sdate to edate
  set work'cct=work'cct+1
  if period(p) eq 4
    set <case work'dct> drawline=work'cct
   set work'dct=work'dct+1
  end if
end loop

work'ehistcol=ehist-sdate+1 
work'edatecol=edate-sdate+1 

deci 1

devi graph postl
picture <access over> file(picname+".eps")
channel reports picture
page frame off
render points 7.4
render leftmargin 100
report
column gap 20
image date quarterly "<year>q<p>"

title #1 left points 7.4, text "Printed: "+today+" "+now
if exists(shocklabel)
title #1 right points 7.4, text "Database: "+shocklabel
else
title #1 right points 7.4, text "Database: "+dbname1
end if
title #2 right points 7.4, text "Created: "+dbdate1
if upper(shockname) eq "FROMFILE"
title #3 points 10, text "Level Table "+tabnum+": "+shocktitle
else
title #3 points 10, text shockname
end if

select date

blank
text "Short-Term Interest Rates"
--blank
--dec 2 
print <deci 2> HO_rs as "  "+HO
print <deci 2> FO_rs as "  "+FO
print <deci 2> HO_rs-FO_rs as "  Differential"

blank
text "Exchange Rates"
--blank
text "  Value of "+FO_currency+" (in "+HO_currency+")"	
print <deci 3> HO_er as "    level"	
--dec 1
print 100*HO_er/HO_er[t-4]-100 as "    % y-o-y "
print 100*(HO_er/HO_er[t-1])**4-100 as "    % q-o-q "
--blank
text "  Value of "+HO_currency+" (in "+FO_currency+")"	
print <deci 3> 1/HO_er as "    level"	
--blank
text "  Real Exchange Rate Gap"
print <deci 2> HO_z_gap as "    "+HO


blank
text "Real GDP Growth"
--blank
text "  "+HO
print 100*HO_gdp/HO_gdp[t-4]-100 as "    % y-o-y"
print 100*(HO_gdp/HO_gdp[t-1])**4-100 as "    % q-o-q"
text "  "+FO
print 100*FO_gdp/FO_gdp[t-4]-100 as "    % y-o-y"
print 100*(FO_gdp/FO_gdp[t-1])**4-100 as "    % q-o-q"

--blank
--text "Cumulative Output Gap"
--blank
--print HO_cumulative_gap as "  "+HO
--print FO_cumulative_gap as "  "+FO

--blank
--text "Sacrifice Ratio"
----blank
----***
----January 24

----series  <over on>  HO_sacrat
----   set <date 2005q1 to endMODELFORECAST> HO_sacrat = 0  
----   set <date 2005q2 to endMODELFORECAST> HO_sacrat = HO_sacrat[t-1] + HO_GDP_GAP

----   set <date ehist+3 to endMODELFORECAST> HO_sacrat = 0  
----   set <date ehist+4 to endMODELFORECAST> HO_sacrat = HO_sacrat[t-1] + HO_GDP_GAP
--print HO_sacrat as "  "+HO
--print FO_sacrat as "  "+FO


blank
text "CPI Inflation"
--blank
text "  "+HO
print 100*HO_cpi/HO_cpi[t-4]-100 as "    % y-o-y"
print 100*(HO_cpi/HO_cpi[t-1])**4-100 as "    % q-o-q"
text "  "+FO
print 100*FO_cpi/FO_cpi[t-4]-100 as "    % y-o-y"
print 100*(FO_cpi/FO_cpi[t-1])**4-100 as "    % q-o-q"

--PK: Jan 19, 2005. Added a Core Phillips Curve equation
blank
text "Core CPI Inflation"
--blank
text "  "+HO
print 100*HO_cpix/HO_cpix[t-4]-100 as "    % y-o-y"
print 100*(HO_cpix/HO_cpix[t-1])**4-100 as "    % q-o-q"
text "  "+FO
print 100*FO_cpix/FO_cpix[t-4]-100 as "    % y-o-y"
print 100*(FO_cpix/FO_cpix[t-1])**4-100 as "    % q-o-q"

blank
text "Price of oil ($)"
print FO_poil as "  World market"
blank
text "Output Gap"
dec 2
print HO_gdp_gap as "  "+HO
print FO_gdp_gap as "  "+FO
blank
text "Potential Output Growth (% q-o-q)"
dec 1
print 100*(HO_gdp_eq/HO_gdp_eq[t-1])**4-100 as "  "+HO
print 100*(FO_gdp_eq/FO_gdp_eq[t-1])**4-100 as "  "+FO
blank


text "Model Residuals and Judgment"
--blank
text "  "+HO
print res_HO_pie as "    Inflation"
--PK: Jan 19, 2005. Added a Core Phillips Curve equation
print res_HO_piex as "    Core Inflation"
print res_HO_gdp_gap as "    Output Gap"
print res_HO_rs as "    Nominal Interest Rate"
print res_HO_lz as "    Real Exchange Rate (percentage points)"
--dec 2
--print res_HO_lz_eq as "    Equilibirum Real Exchange Rate (percentage points)"
blank
text "  "+FO
dec 1
print res_FO_pie as "    Inflation"
--PK: Jan 19, 2005. Added a Core Phillips Curve equation
print res_FO_piex as "    Core Inflation"
dec 2
print res_FO_gdp_gap as "    Output Gap"
dec 1
print res_FO_rs as "    Nominal Interest Rate"
print res_FO_rel_poil_gap as "    Oil equation (percentage points)"



scalar work'S_line = 5
scalar work'N_lines = 75
if ehistcol eq edatecol
  stroke <render chromatic color, shading paint, scolor c7, color white> box  (ehistcol,work'S_line) to (edatecol,work'N_lines)
else
  stroke <render chromatic color, shading paint, scolor c7, color white> box  (ehistcol+1,work'S_line) to (edatecol,work'N_lines)
end if

loop for i=firstvalue(drawline) to lastvalue(drawline)
  stroke line (work'S_line,work'N_lines) down drawline[i]
end loop

end report
picture terminal
close all

end procedure


--**********************************************************************
procedure $table
argument db1,db2,sdate,ehist,edate,picname,shockname

try
 close all
end try
reset
plot #1 color blue
plot #2 color red
plot #3 color black
abort on
show vertical
length full
ignore on
over on
deci auto
object precision
freq q

open <acc r> countrynames as cn
open <acc r> db1 as s
open <acc r> db2 as c

image date daily "<m>/<d>/<year>" 
scalar work'dbname1: string=upper(ltrim(mirror(substring(mirror(filespec(s)),4,location(mirror(filespec(s)),"\"))),"\"))
scalar work'dbdate1:string=datefmt(dbupdated(s))
scalar work'dbname2: string=upper(ltrim(mirror(substring(mirror(filespec(c)),4,location(mirror(filespec(c)),"\"))),"\"))
scalar work'dbdate2:string=datefmt(dbupdated(c))
date sdate to edate
page division colu 1, rows 1

series work'drawline by case
work'dct=1
work'cct=0
loop for p=sdate to edate
  set work'cct=work'cct+1
  if period(p) eq 4
    set <case work'dct> drawline=work'cct
   set work'dct=work'dct+1
  end if
end loop

work'ehistcol=ehist-sdate+1 
work'edatecol=edate-sdate+1 

dec 1

devi graph postl
picture <access over> file(picname+".eps")
channel reports picture
page frame off
render points 7.4
render leftmargin 100
report
column gap 20
image date quarterly "<year>q<p>"

title #1 left points 7.4, text "Printed: "+today+" "+now

--if exists(shocklabel)
--title #3 left points 7.4, text "Shock Database: "+shocklabel
--else
--title #3 left points 7.4, text "Shock Database: "+dbname1
--end if

--if exists(controllabel)
--title #2 left points 7.4, text "Control Database: "+controllabel
--else
--title #2 left points 7.4, text "Control Database: "+dbname2
--end if

if upper(shockname) eq "FROMFILE"
title #2 points 10, text "Shock-Control Table "+tabnum+": "+shocktitle
else
title #2 points 10, text shockname
end if


if exists(controllabel) and exists(shocklabel)
title #3 points 8, text "(Deviations: "+shocklabel+" - "+controllabel+")"
else
title #3 points 8, text "(Deviations: "+dbname1+" - "+dbname2+")"
end if

select date

blank
text "Short-Term Interest Rates"
blank
print s'HO_rs-c'HO_rs as "  "+HO
print s'FO_rs-c'FO_rs as "  "+FO
print s'HO_rs-s'FO_rs-(c'HO_rs-c'FO_rs) as "  Differential"
blank
text "Exchange Rates"
blank
text "  Value of "+FO_currency+" (in "+HO_currency+")"	
print <deci 3> (s'HO_er/c'HO_er-1)*100 as "    level"	
print 100*((s'HO_er/s'HO_er[t-4])-(c'HO_er/c'HO_er[t-4])) as "    % y-o-y "
print 100*((s'HO_er/s'HO_er[t-1])**4-(c'HO_er/c'HO_er[t-1])**4) as "    % q-o-q "
blank
text "  Value of "+HO_currency+" (in "+FO_currency+")"	
print <deci 3> 100*(1/s'HO_er)/(1/c'HO_er)-100 as "    level"	
blank
text "  Real Exchange Rate Gap"
print <deci 2> s'HO_z_gap-c'HO_z_gap as  "  "+HO
blank
text "Real GDP Growth"
blank
text "  "+HO
print 100*(s'HO_gdp/s'HO_gdp[t-4]-c'HO_gdp/c'HO_gdp[t-4]) as "    % y-o-y"
print 100*((s'HO_gdp/s'HO_gdp[t-1])**4-(c'HO_gdp/c'HO_gdp[t-1])**4) as "    % q-o-q"
text "  "+FO
print 100*(s'FO_gdp/s'FO_gdp[t-4]-c'FO_gdp/c'FO_gdp[t-4]) as "    % y-o-y"
print 100*((s'FO_gdp/s'FO_gdp[t-1])**4-(c'FO_gdp/c'FO_gdp[t-1])**4) as "    % q-o-q"
blank
text "CPI Inflation"
blank
text "  "+HO
print 100*(s'HO_cpi/s'HO_cpi[t-4]-c'HO_cpi/c'HO_cpi[t-4]) as "      % y-o-y"
print 100*((s'HO_cpi/s'HO_cpi[t-1])**4-(c'HO_cpi/c'HO_cpi[t-1])**4) as "      % q-o-q"
text "  "+FO
print 100*(s'FO_cpi/s'FO_cpi[t-4]-c'FO_cpi/c'FO_cpi[t-4]) as "      % y-o-y"
print 100*((s'FO_cpi/s'FO_cpi[t-1])**4-(c'FO_cpi/c'FO_cpi[t-1])**4) as "      % q-o-q"
blank
text "Price of oil ($)"
print 100*s'FO_poil/c'FO_poil-100 as "  (Percentage difference)"
blank
text "Output Gap"
print s'HO_gdp_gap-c'HO_gdp_gap as "  "+HO
print s'FO_gdp_gap-c'FO_gdp_gap as "  "+FO
blank
text "Potential Output Growth (% q-o-q)"
print 100*((s'HO_gdp_eq/s'HO_gdp_eq[t-1])**4-(c'HO_gdp_eq/c'HO_gdp_eq[t-1])**4) as "  "+HO
print 100*((s'FO_gdp_eq/s'FO_gdp_eq[t-1])**4-(c'FO_gdp_eq/c'FO_gdp_eq[t-1])**4) as "  "+FO
blank
text "Model Residuals and Judgement"
blank
text "  "+HO
print s'res_HO_pie-c'res_HO_pie as "    Inflation"
print s'res_HO_gdp_gap-c'res_HO_gdp_gap as "    Output Gap"
print s'res_HO_rs-c'res_HO_rs as "    Nominal Interest Rate"
print s'res_HO_lz-c'res_HO_lz as "    Real Exchange Rate (percentage points)"
blank
text "  "+FO
print s'res_FO_pie-c'res_FO_pie as "    Inflation"
print s'res_FO_gdp_gap-c'res_FO_gdp_gap as "    Output Gap"
print s'res_FO_rs-c'res_FO_rs as "    Nominal Interest Rate"
print s'res_FO_rel_poil_gap-c'res_FO_rel_poil_gap as "    Oil equation (percentage points)"

work'S_line = 7
work'N_lines = 69

if ehistcol eq edatecol
  stroke <render chromatic color, shading paint, scolor c7, color white> box  (ehistcol,work'S_line) to (edatecol,work'N_lines)
else
  stroke <render chromatic color, shading paint, scolor c7, color white> box  (ehistcol+1,work'S_line) to (edatecol,work'N_lines)
end if

loop for i=firstvalue(drawline) to lastvalue(drawline)
  stroke line (work'S_line,work'N_lines) down drawline[i]
end loop

end report
picture terminal

-- create a database for used for PP graphs
open <access over> PPgraphs3	as pp
glue "_"
loop for cc in {ho,fo}
 pp'cc&poil&s1=c'cc&poil
 pp'cc&poil&s4=s'cc&poil
 
 pp'cc&gdp_eq_gr_qar&s1=100*(c'cc&gdp_eq/c'cc&gdp_eq[t-1])**4-100
 pp'cc&gdp_eq_gr_qar&s4=100*(s'cc&gdp_eq/s'cc&gdp_eq[t-1])**4-100
 pp'cc&gdp_gap&s1=c'cc&gdp_gap
 pp'cc&gdp_gap&s4=s'cc&gdp_gap
 
 pp'cc&gdp_gr_qar&s1=100*(c'cc&gdp/c'cc&gdp[t-1])**4-100
 pp'cc&gdp_gr_qar&s4=100*(s'cc&gdp/s'cc&gdp[t-1])**4-100
 
 pp'cc&cpix_infl_yoy&s1=100*c'cc&cpix/c'cc&cpix[t-4]-100
 pp'cc&cpix_infl_yoy&s4=100*s'cc&cpix/s'cc&cpix[t-4]-100
 pp'cc&cpi_infl_yoy&s1=100*c'cc&cpi/c'cc&cpi[t-4]-100
 pp'cc&cpi_infl_yoy&s4=100*s'cc&cpi/s'cc&cpi[t-4]-100
 pp'cc&rs&s1=c'cc&rs
 pp'cc&rs&s4=s'cc&rs
end loop
close all

end procedure



--************************************************************************
procedure $summarytable
argument shk,con,simdateq,sdateq,edateq,sdatea,edatea,picname,shockname

try
 close all
end try
reset
plot #1 color blue
plot #2 color red
plot #3 color black
abort on
show vertical
length full
ignore on
over on
pause off
ignore on
devi graph postp
channel reports picture
page frame off
page divi rows 4, colu 2
glue "_"

open <acc r> countrynames as cn
open <acc r> shk as s
open <acc r> con as c

freq a
exec("scalar <freq annual> simdatea: date = "+datefmt(simdateq, "<YEAR>"))
freq q
deci 1
date sdateq-4 to sdateq-4+23

--if class(countrylist) eq "SERIES"
--clist=nl(countrylist)
--<over on> countrylist=clist
--end if

<over on> countrylist = {HO, FO}

sdateqnum = (15 - month(sdateq))/3
edateqnum = (month(edateq)) /3

loop for cc in countrylist
 picture <access over> file(picname+lower(name(cc))+".eps")

 image date daily "<m>/<d>/<year>" 
 scalar work'dbname1: string=upper(ltrim(mirror(substring(mirror(filespec(s)),4,location(mirror(filespec(s)),"\"))),"\"))
 scalar work'dbdate1: string=datefmt(dbupdated(s))
 date sdatea to edatea
 series work'drawline by case

 cell(4,1)
 tick label size xsmall
 legend on
 legend contents name off, desc on
 legend size xsmall
 legend divi colu 2
 axis on
 graph
  title #1 text "Inflation, Interest Rates and the Output Gap", size small
  data  100*s'cc&cpi/s'cc&cpi[t-4]-100 <plot desc "CPI Inflation (y-o-y)">, s'cc&gdp_gap <plot desc "Output Gap">, s'cc&rs <plot desc "Interest Rate">
  draw marking <depict axis left> at 0
 end graph

 cell (4,2)
 graph
  title #1 text "Real GDP Growth", size small
  data 100*s'cc&gdp/s'cc&gdp[t-4]-100 <plot desc "% y-o-y">, 100*(s'cc&gdp/s'cc&gdp[t-1])**4-100 <plot desc "% q-o-q">
  draw marking <depict axis left> at 0
 end graph


 cell (1 to 3, 1 to 2)
 render points 9
-- render leftmargin 80
 fill "  "
 report
  title #1 right points 7, text "Created: "+dbdate1
  if upper(shockname) eq "FROMFILE"

--   title #2 center points 14, text string(cc)+": "+"Summary Table "+tabnum+": "+shocktitle
--title #2 center points 14, text string(cc)+": "+""+tabnum+": "+shocktitle
title #2 center points 14, text string(cc)+": "+shocktitle
 

 else
   title #2 center points 14, text shockname
  end if
--  title #3 center points 14, "with Demand and Potential Output Effects "
  title #4 center points 12, text ""
  if exists(c'shocktitle)
   title #5 center points 10, text "Deviations from "+c'shocktitle
  else
   title #5 center points 10, text "Deviations from the Latest Baseline"
  end if

  title #6 center points 8, text "(percent deviation) or [percentage point deviation]"

  series <freq q> temp.q
  observed(temp.q)=averaged
  series <freq a> temp.a
  freq q
  cntr = 0
  dd=edateq-sdateq+1
  select major #1 "Quarterly" over dd
  select major #2 "" over dd fill "_"
  loop for yyy = sdateq to edateq

   if yyy eq sdateq
      select major #3 datefmt(yyy,"<YEAR>") over sdateqnum
   else
      if(year(yyy) eq year(edateq))
        if year(yyy-1) +1 eq year(yyy)
	   select major #3 datefmt(yyy,"<YEAR>") over edateqnum
        end if
      else
        if year(yyy-1)+1 eq year(yyy)
	   select major #3 datefmt(yyy,"<YEAR>") over 4
        end if
      end if
   end if
   set cntr=cntr+1
   select value temp.q[yyy] as datefmt(yyy,"Q<P>")
   if cntr eq 4
    set cntr=0
   end if
 
  end loop
  freq a
  dd=edatea-sdatea+1
  -- column gap 25 
  select major #1 "Annual" over dd
  select major #2 "" over dd fill "_"
  select major #3 "" over dd
  loop for yyy = sdatea to edatea
   select value temp.a[yyy] as string(yyy)
  end loop
  blank
  blank

  set temp.q=s'cc&rs
  set <convert on> temp.a=convert(temp.q)
dec 2
  print s'cc&rs as "Short-term Interest Rate"
  set temp.q=s'cc&rs-c'cc&rs
  set <convert on> temp.a=convert(temp.q)
  set <date sdateq to simdateq-1> temp.q=ND
  set <date sdatea to simdatea-1> temp.a=ND
  blank <render points 2>
  print <render points 7; positive signed; lprefix"["; suffix "]"> s'cc&rs-c'cc&rs as "  "
  blank 



----------------------------------------------------------------------------------------------
--PK: May 25, 2007
-- Shock to Eqbm RER : Need some extra lines in document
--set temp.q=s'cc&rr
--set <convert on> temp.a=convert(temp.q)
dec 1
--print s'cc&rr as "Real Interest Rate"
--set temp.q=s'cc&rr-c'cc&rr
--set <convert on> temp.a=convert(temp.q)
--set <date sdateq to simdateq-1> temp.q=ND
--set <date sdatea to simdatea-1> temp.a=ND
--blank <render points 2>
--print <render points 7; positive signed; lprefix"["; suffix "]"> s'cc&rr-c'cc&rr as ""
--blank 

--set temp.q=s'cc&rr_gap
--set <convert on> temp.a=convert(temp.q)
dec 1
--print s'cc&rr_gap as "Real Interest Rate Gap"
--set temp.q=s'cc&rr_gap-c'cc&rr_gap
--set <convert on> temp.a=convert(temp.q)
--set <date sdateq to simdateq-1> temp.q=ND
--set <date sdatea to simdatea-1> temp.a=ND
--blank <render points 2>
--print <render points 7; positive signed; lprefix"["; suffix "]"> s'cc&rr_gap-c'cc&rr_gap as "  "
--blank

--set temp.q=s'HO_lz
--set <convert on> temp.a=convert(temp.q)
dec 1
--print s'HO_lz as "Real Exchange Rate"
--------  set temp.q=100*(s'HO_lz)/(c'HO_lz)-100
--set temp.q=s'HO_lz - c'HO_lz

--set <convert on> temp.a=convert(temp.q)
--set <date sdateq to simdateq-1> temp.q=ND
--set <date sdatea to simdatea-1> temp.a=ND
--blank <render points 2>
-------  print <render points 7; positive signed; lprefix"("; suffix ")"> 100*(s'HO_lz)/(c'HO_lz)-100 as "  "
--print <render points 7; positive signed; lprefix"["; suffix "]"> s'HO_lz-c'HO_lz as "  "
--blank

--set temp.q=s'HO_lz_eq
--set <convert on> temp.a=convert(temp.q)
dec 1
--print s'HO_lz_eq as "Equilibrium Real Exchange Rate"
-------  set temp.q=100*(s'HO_lz_eq)/(c'HO_lz_eq)-100
--set temp.q=s'HO_lz_eq-c'HO_lz_eq
--set <convert on> temp.a=convert(temp.q)
--set <date sdateq to simdateq-1> temp.q=ND
--set <date sdatea to simdatea-1> temp.a=ND
--blank <render points 2>
------  print <render points 7; positive signed; lprefix"("; suffix ")"> 100*(s'HO_lz_eq)/(c'HO_lz_eq)-100 as "  "
--print <render points 7; positive signed; lprefix"["; suffix "]"> s'HO_lz_eq-c'HO_lz_eq as "  "
--blank


--set temp.q=s'HO_z_gap
--set <convert on> temp.a=convert(temp.q)
dec 1
--print s'HO_z_gap as "Real Exchange Rate Gap"
--set temp.q=s'HO_z_gap-c'HO_z_gap
--set <convert on> temp.a=convert(temp.q)
--set <date sdateq to simdateq-1> temp.q=ND
--set <date sdatea to simdatea-1> temp.a=ND
--blank <render points 2>
--print <render points 7; positive signed; lprefix"["; suffix "]"> s'HO_z_gap-c'HO_z_gap as ""
--blank

--set temp.q=s'HO_risk_eq
--set <convert on> temp.a=convert(temp.q)
dec 1
--print s'HO_risk_eq as "Equilibrium Risk Premium"
--set temp.q=s'HO_risk_eq-c'HO_risk_eq
--set <convert on> temp.a=convert(temp.q)
--set <date sdateq to simdateq-1> temp.q=ND
--set <date sdatea to simdatea-1> temp.a=ND
--blank <render points 2>
--print <render points 7; positive signed; lprefix"["; suffix "]"> s'HO_risk_eq-c'HO_risk_eq as "  "
--blank
--   end PK: May 25, 2007
----------------------------------------------------------------------------------------------


-- (+) is an appn
-- (+) is a depn

   set temp.q=(1/s'HO_er)
   set <convert on> temp.a=convert(temp.q)
deci 3
   print (1/s'HO_er) as "Value of "+HO_currency+" (in "+FO_currency+")"
deci 1
   set temp.q=100*(1/s'HO_er)/(1/c'HO_er)-100
   set <convert on> temp.a=convert(temp.q)
   set <date sdateq to simdateq-1> temp.q=ND
   set <date sdatea to simdatea-1> temp.a=ND
   blank <render points 2>
   print <render points 7; positive signed; lprefix"("; suffix ")"> 100*(1/s'HO_er)/(1/c'HO_er)-100 as "  "
  blank


--   set temp.q=(s'HO_er)
--   set <convert on> temp.a=convert(temp.q)
--deci 3
--   print (s'HO_er) as "Value of "+FO_currency+" (in "+HO_currency+")"
--deci 1
--   set temp.q=100*(s'HO_er)/(c'HO_er)-100
--   set <convert on> temp.a=convert(temp.q)
--   set <date sdateq to simdateq-1> temp.q=ND
--   set <date sdatea to simdatea-1> temp.a=ND
--   blank <render points 2>
--   print <render points 7; positive signed; lprefix"("; suffix ")"> 100*(s'HO_er)/(c'HO_er)-100 as "  "
--  blank


  

  text "Real GDP Growth"
  blank
  set temp.q=100*s'cc&gdp/s'cc&gdp[t-4]-100
  set <convert on> temp.a=convert(temp.q)
  print 100*s'cc&gdp/s'cc&gdp[t-4]-100 as "  % y-o-y"
  set temp.q=100*(s'cc&gdp/s'cc&gdp[t-4]-c'cc&gdp/c'cc&gdp[t-4])
  set <convert on> temp.a=convert(temp.q)
  set <date sdateq to simdateq-1> temp.q=ND
  set <date sdatea to simdatea-1> temp.a=ND
  blank <render points 2>
  print <render points 7; positive signed; lprefix"["; suffix "]"> 100*(s'cc&gdp/s'cc&gdp[t-4]-c'cc&gdp/c'cc&gdp[t-4]) as "  "
  blank <render points 4>
  set temp.q=100*(s'cc&gdp/s'cc&gdp[t-1])**4-100
  set temp.a=ND
  print 100*(s'cc&gdp/s'cc&gdp[t-1])**4-100 as "  % q-o-q"
  set temp.q=100*((s'cc&gdp/s'cc&gdp[t-1])**4-(c'cc&gdp/c'cc&gdp[t-1])**4)
  set <date sdateq to simdateq-1> temp.q=ND
  set temp.a=ND
  blank <render points 2>
  print <render points 7; positive signed; lprefix"["; suffix "]"> 100*((s'cc&gdp/s'cc&gdp[t-1])**4-(c'cc&gdp/c'cc&gdp[t-1])**4) as "  "
  blank
  blank

  text "CPI Inflation"
  blank
  set temp.q=100*s'cc&cpi/s'cc&cpi[t-4]-100
  set <convert on> temp.a=convert(temp.q)
dec 1
  print 100*s'cc&cpi/s'cc&cpi[t-4]-100 as "  % y-o-y"
  set temp.q=100*(s'cc&cpi/s'cc&cpi[t-4]-c'cc&cpi/c'cc&cpi[t-4])
  set <convert on> temp.a=convert(temp.q)
  set <date sdateq to simdateq-1> temp.q=ND
  set <date sdatea to simdatea-1> temp.a=ND
  blank <render points 2>
  print <render points 7; positive signed; lprefix"["; suffix "]"> 100*(s'cc&cpi/s'cc&cpi[t-4]-c'cc&cpi/c'cc&cpi[t-4]) as "  "
  blank <render points 4>
  set temp.q=100*(s'cc&cpi/s'cc&cpi[t-1])**4-100
  set temp.a=ND
  print 100*(s'cc&cpi/s'cc&cpi[t-1])**4-100 as "  % q-o-q"
  set temp.q=100*((s'cc&cpi/s'cc&cpi[t-1])**4-(c'cc&cpi/c'cc&cpi[t-1])**4)
  set <date sdateq to simdateq-1> temp.q=ND
  set temp.a=ND
  blank <render points 2>
  print <render points 7; positive signed; lprefix"["; suffix "]"> 100*((s'cc&cpi/s'cc&cpi[t-1])**4-(c'cc&cpi/c'cc&cpi[t-1])**4) as "  "
  blank
--  blank


  text "Core CPI Inflation"
  blank
  set temp.q=100*s'cc&cpix/s'cc&cpix[t-4]-100
  set <convert on> temp.a=convert(temp.q)
dec 1
--dec 3
  print 100*s'cc&cpix/s'cc&cpix[t-4]-100 as "  % y-o-y"
  set temp.q=100*(s'cc&cpix/s'cc&cpix[t-4]-c'cc&cpix/c'cc&cpix[t-4])
  set <convert on> temp.a=convert(temp.q)
  set <date sdateq to simdateq-1> temp.q=ND
  set <date sdatea to simdatea-1> temp.a=ND
  blank <render points 2>
  print <render points 7; positive signed; lprefix"["; suffix "]"> 100*(s'cc&cpix/s'cc&cpix[t-4]-c'cc&cpi/c'cc&cpix[t-4]) as "  "
  blank <render points 4>
  set temp.q=100*(s'cc&cpix/s'cc&cpix[t-1])**4-100
  set temp.a=ND
  print 100*(s'cc&cpix/s'cc&cpix[t-1])**4-100 as "  % q-o-q"
  set temp.q=100*((s'cc&cpix/s'cc&cpix[t-1])**4-(c'cc&cpix/c'cc&cpix[t-1])**4)
  set <date sdateq to simdateq-1> temp.q=ND
  set temp.a=ND
  blank <render points 2>
  print <render points 7; positive signed; lprefix"["; suffix "]"> 100*((s'cc&cpix/s'cc&cpix[t-1])**4-(c'cc&cpix/c'cc&cpix[t-1])**4) as "  "
  blank
--  blank

dec 1
  set temp.q=s'FO_poil
  set <convert on> temp.a=convert(temp.q)
  print s'FO_poil as "Price of oil ("+FO_currency+")"
  set temp.q=100*s'FO_poil/c'FO_poil-100
  set <convert on> temp.a=convert(temp.q)
  set <date sdateq to simdateq-1> temp.q=ND
  set <date sdatea to simdatea-1> temp.a=ND
  blank <render points 2>
  print <render points 7; positive signed; lprefix"("; suffix ")"> 100*s'FO_poil/c'FO_poil-100 as "  "
  blank


dec 2 
--dec 3
  set temp.q=s'cc&gdp_gap
  set <convert on> temp.a=convert(temp.q)
  print s'cc&gdp_gap as "Output Gap"
 
 set temp.q=s'cc&gdp_gap-c'cc&gdp_gap
  set <convert on> temp.a=convert(temp.q)
  set <date sdateq to simdateq-1> temp.q=ND
  set <date sdatea to simdatea-1> temp.a=ND
  blank <render points 2>
  print <render points 7; positive signed; lprefix"["; suffix "]"> s'cc&gdp_gap-c'cc&gdp_gap as "  "
  blank


  text "Potential Output Growth"
  blank
dec 1
  set temp.q=100*s'cc&gdp_eq/s'cc&gdp_eq[t-4]-100
  set <convert on> temp.a=convert(temp.q)
  print 100*s'cc&gdp_eq/s'cc&gdp_eq[t-4]-100 as "  % y-o-y"

  set temp.q=100*(s'cc&gdp_eq/s'cc&gdp_eq[t-4]-c'cc&gdp_eq/c'cc&gdp_eq[t-4])
  set <convert on> temp.a=convert(temp.q)
  set <date sdateq to simdateq-1> temp.q=ND
  set <date sdatea to simdatea-1> temp.a=ND
  blank <render points 2>
  print <render points 7; positive signed; lprefix"["; suffix "]"> 100*(s'cc&gdp_eq/s'cc&gdp_eq[t-4]-c'cc&gdp_eq/c'cc&gdp_eq[t-4]) as "  "
  blank <render points 4>



--  set temp.q=100*(s'cc&gdp_eq/s'cc&gdp_eq[t-1])**4-100
--  set temp.a=ND
--  print 100*(s'cc&gdp_eq/s'cc&gdp_eq[t-1])**4-100 as "  % q-o-q"
--  set temp.q=100*((s'cc&gdp_eq/s'cc&gdp_eq[t-1])**4-(c'cc&gdp_eq/c'cc&gdp_eq[t-1])**4)
--  set <date sdateq to simdateq-1> temp.q=ND
--  set temp.a=ND
--  blank <render points 2>
--  print <render points 7; positive signed; lprefix"["; suffix "]"> 100*((s'cc&gdp_eq/s'cc&gdp_eq[t-1])**4-(c'cc&gdp_eq/c'cc&gdp_eq[t-1])**4) as "  "
--  blank
--  blank
  
  lnnum = sdateqnum + edateqnum + (year(edateq)-year(sdateq) -1)*4
  stroke line down lnnum

 end report


 picture terminal
end loop

close all

end procedure


--**********************************************************************
procedure $summarygraph
argument shk,con,sdateq,edateq,picname,shockname

try
 close all
end try
reset
plot #1 color blue
plot #2 color red
plot #3 color black
abort on
show vertical
length full
ignore on
over on
pause off
ignore on
devi graph postp
page frame off
page divi rows 4, colu 2
glue "_"
freq q

date sdateq to edateq

open <acc r> countrynames as cn
open <acc r> shk as s
open <acc r> con as c

tick mark right on
tick label right on

glue "_"

<over on> countrylist = {HO, FO}
loop for cc in countrylist
picture <access over> file(picname+lower(name(cc))+".eps")
 page divi rows 4, colu 1
 if upper(shockname) eq "FROMFILE"
 page title #2 text string(cc)+": Summary Graph "+tabnum+": "+shocktitle, size medium
 else
 page title #2 text string(cc)+": "+shockname, size medium
 end if
 tick label size xsmall
 legend on
 legend contents name off, desc on
 legend size xsmall
 legend division column 2

 axis on
 cell (1,1)
 graph
  title #1 text "Year-on-Year GDP Growth", size small
  data 100*s'cc&gdp/s'cc&gdp[t-4]-100 <plot desc "Shock">,  100*c'cc&gdp/c'cc&gdp[t-4]-100 <plot desc "Control">
  draw marking <depict axis left> at 0
 end graph
 cell (2,1)
 graph
  title #1 text "Year-on-Year Inflation", size small
  data 100*s'cc&cpi/s'cc&cpi[t-4]-100 <plot desc "Shock">, 100*c'cc&cpi/c'cc&cpi[t-4]-100 <plot desc "Control">
  draw marking <depict axis left> at 0
 end graph
 cell (3,1)
 graph
  title #1 text "Short-Term Interest Rate", size small
  data s'cc&rs <plot desc "Shock">,  c'cc&rs <plot desc "Control">
  draw marking <depict axis left> at 0
 end graph
 cell (4,1)
 graph
--  title #1 text "Year-on-Year Potential GDP Growth", size small
--  data 100*s'cc&gdp_eq/s'cc&gdp_eq[t-4]-100 <plot desc "Shock">,  100*c'cc&gdp_eq/c'cc&gdp_eq[t-4]-100 <plot desc "Control">
  title #1 text "Output Gap", size small
  data s'cc&gdp_gap <plot desc "Shock">,  c'cc&gdp_gap <plot desc "Control">
  draw marking <depict axis left> at 0
 end graph

 
picture terminal
end loop

close all

end procedure


--************************************************************************
--A LA G3 FORMAT
procedure $levelgraph
argument shk,con,sdate,ehist,edate,picname,shockname

reset
abort on
over on
freq q
page divi rows 3, colu 2
page margins vertical 0.005, horizontal 0.005
page title area length standard
devi graph postp
legend off
axis on
page frame off
image date daily "<m>/<d>/<year>" 
glue "_"

open <acc r> countrynames as cn
open <acc r> shk as s
open <acc r> con as c

scalar work'dbname1: string=upper(ltrim(mirror(substring(mirror(filespec(s)),4,location(mirror(filespec(s)),"\"))),"\"))
scalar work'dbdate1: string=datefmt(dbupdated(s))
date sdate to edate

picture <access over> file(lower(picname)+"levelgraph.eps")
picture terminal

page title #1 left text "Printed: "+today+" "+now, size xsmall
if exists(shocklabel)
page title #2 right text "Database: "+shocklabel, size xsmall
else
page title #2 right text "Database: "+work'dbname1, size xsmall
end if
page title #3 right text "Created: "+work'dbdate1, size xsmall

<over on> countrylist = {HO, FO}
loop for cc in countrylist

 picture <access append> file(lower(picname)+"levelgraph.eps")

  if upper(shockname) eq "FROMFILE"
  page title #4 text string(cc)+": Level Graph "+tabnum+": "+shocktitle, size medium
  else
  page title #4 text string(cc)+": "+shockname, size medium
  end if
  
  page title #5 text "Core Variables", size small

  title #1 text "GDP", size small
  title #2 null
  graph s'cc&gdp, c'cc&gdp
  draw marking <depict axis bottom> at ehist

  title #1 text "Output Gap", size small
  title #2 null
  graph s'cc&gdp_gap, c'cc&gdp_gap
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0


--********************************************
  title #1 text "Sacrifice Ratio", size small
  title #2 null
  graph s'cc&sacrat, c'cc&sacrat
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0
--********************************************



  title #1 text "Core Inflation", size small
  title #2 text "% y-o-y", size xsmall
  graph s'cc&pie4x, c'cc&pie4x
  draw marking <depict axis bottom> at ehist

  title #1 text "Core Inflation", size small
  title #2 text "% q@ar", size xsmall
  graph s'cc&piex, c'cc&piex
  draw marking <depict axis bottom> at ehist

  title #1 text "Headline Inflation", size small
  title #2 text "% y-o-y", size xsmall
  graph s'cc&pie4, c'cc&pie4
  draw marking <depict axis bottom> at ehist

  title #1 text "Headline Inflation", size small
  title #2 text "% q@ar", size xsmall
  graph s'cc&pie, c'cc&pie
  draw marking <depict axis bottom> at ehist

  title #1 text "Short-term Interest Rate (%)", size small
  title #2 null
  graph s'cc&rs, c'cc&rs
  draw marking <depict axis bottom> at ehist

  title #1 text "Nominal Exchange Rate", size small
  title #2 text "local unit per "+FO_currency, size xsmall 
  graph s'HO_er, c'HO_er
  draw marking <depict axis bottom> at ehist

--  title #1 text "Real Effective Exchange Rate", size small
--  title #2 text "trade weights,1997=100", size xsmall
--  graph 100*exp(s'cc&reer_t), 100*exp(c'cc&reer_t)
--  draw marking <depict axis bottom> at ehist

--  title #1 text "Real Effective Exchange Rate", size small
--  title #2 text "import weights,1997=100", size xsmall
--  graph 100*exp(s'cc&reer_m), 100*exp(c'cc&reer_m)
--  draw marking <depict axis bottom> at ehist

  title #1 text "Real Exchange Rate", size small
  title #2 text "+ve is a depreciation vs "+FO, size xsmall
-- note: the division by a 100 is to solve an exp(90) high floating point problem ...
  graph exp(s'HO_lz/100), exp(c'HO_lz/100)
  draw marking <depict axis bottom> at ehist

--  title #1 text "Foreign Activity", size small
--  title #2 text "export weights", size xsmall
--  graph s'cc&fact, c'cc&fact
--  draw marking <depict axis bottom> at ehist

  title #1 text "Price of Oil", size small
  title #2 text FO_currency, size xsmall
  graph s'FO_poil, c'FO_poil
  draw marking <depict axis bottom> at ehist

--  title #1 text "PGDP Inflation", size small
--  title #2 text "% q@ar", size xsmall
--  graph s'cc&pie_pgdp, c'cc&pie_pgdp
--  draw marking <depict axis bottom> at ehist

 picture terminal
 picture <access append> file(lower(picname)+"levelgraph.eps")

  page title #4 text string(cc)+": "+shockname, size medium
  page title #5 text "Residuals", size small

  title #1 text "Output Gap", size small
  title #2 null
  graph s'res&cc&gdp_gap, c'res&cc&gdp_gap
  draw marking <depict axis left> at 0
  draw marking <depict axis bottom> at ehist

  title #1 text "Core Inflation", size small
  graph s'res&cc&piex, c'res&cc&piex
  draw marking <depict axis left> at 0
  draw marking <depict axis bottom> at ehist

  title #1 text "Headline Inflation", size small
  graph s'res&cc&pie, c'res&cc&pie
  draw marking <depict axis left> at 0
  draw marking <depict axis bottom> at ehist

--  title #1 text "PGDP Inflation", size small
--  graph s'res&cc&pie_pgdp, c'res&cc&pie_pgdp
--  draw marking <depict axis left> at 0
--  draw marking <depict axis bottom> at ehist

  title #1 text "Short-term Interest Rate", size small
  graph s'res&cc&rs, c'res&cc&rs
  draw marking <depict axis left> at 0
  draw marking <depict axis bottom> at ehist

  title #1 text "Real Exchange Rate", size small
  graph s'res_HO_lz, c'res_HO_lz
  draw marking <depict axis left> at 0
  draw marking <depict axis bottom> at ehist

  title #1 text "Real Price of Oil", size small
  graph s'res_FO_rel_poil_gap, c'res_FO_rel_poil_gap
  draw marking <depict axis left> at 0
  draw marking <depict axis bottom> at ehist

  title #1 text "Potential Output", size small
  graph s'res&cc&lgdp_eq, c'res&cc&lgdp_eq
  draw marking <depict axis left> at 0
  draw marking <depict axis bottom> at ehist

  title #1 text "Potential Output Growth", size small
  graph s'res&cc&growth, c'res&cc&growth
  draw marking <depict axis left> at 0
  draw marking <depict axis bottom> at ehist

  title #1 text "Core Inflation Target", size small
  graph s'res&cc&pietarget, c'res&cc&pietarget
  draw marking <depict axis left> at 0
  draw marking <depict axis bottom> at ehist

--  title #1 text "Equilibrium Interest Rate", size small
--  graph s'res&cc&rr_eq, c'res&cc&rr_eq
--  draw marking <depict axis left> at 0
--  draw marking <depict axis bottom> at ehist

  title #1 text "Equilibrium Real Exchange Rate", size small
  title #2 text "+ve is a depreciation vs"+FO, size xsmall
  graph s'res_HO_lz_eq, c'res_HO_lz_eq
  draw marking <depict axis left> at 0
  draw marking <depict axis bottom> at ehist

-- picture terminal
 
end loop
close s,c,cn

end procedure



--************************************************************************
--A LA G3 FORMAT
procedure $graph
argument shk,con,sdate,ehist,edate,picname,shockname

reset
abort on
over on
freq q
page divi rows 3, colu 2
page margins vertical 0.005, horizontal 0.005
page title area length standard
devi graph postp
legend off
axis on
page frame off
image date daily "<m>/<d>/<year>" 
glue "_"

open <acc r> countrynames as cn
open <acc r> shk as s
open <acc r> con as c

scalar work'dbname1: string=upper(ltrim(mirror(substring(mirror(filespec(s)),4,location(mirror(filespec(s)),"\"))),"\"))
scalar work'dbdate1: string=datefmt(dbupdated(s))
date sdate to edate

picture <access over> file(lower(picname)+"graph.eps")
picture terminal

page title #1 left text "Printed: "+today+" "+now, size xsmall
if exists(shocklabel)
page title #2 right text "Database: "+shocklabel, size xsmall
else
page title #2 right text "Database: "+work'dbname1, size xsmall
end if
page title #3 right text "Created: "+work'dbdate1, size xsmall

<over on> countrylist = {HO, FO}
loop for cc in countrylist

 picture <access append> file(lower(picname)+"graph.eps")

  if upper(shockname) eq "FROMFILE"
  page title #4 text string(cc)+": Graph "+tabnum+": "+shocktitle, size medium
  else
  page title #4 text string(cc)+": "+shockname, size medium
  end if 
  page title #5 text "Core Variables", size small

  title #1 text "GDP", size small
  title #2 null
  graph 100*s'cc&gdp/c'cc&gdp-100
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

  title #1 text "Output Gap", size small
  title #2 null
  graph s'cc&gdp_gap-c'cc&gdp_gap
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

  title #1 text "Core Inflation", size small
  title #2 text "% y-o-y", size xsmall
  graph s'cc&pie4x-c'cc&pie4x
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

  title #1 text "Core Inflation", size small
  title #2 text "% q@ar", size xsmall
  graph s'cc&piex-c'cc&piex
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

  title #1 text "Headline Inflation", size small
  title #2 text "% y-o-y", size xsmall
  graph s'cc&pie4-c'cc&pie4
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

  title #1 text "Headline Inflation", size small
  title #2 text "% q@ar", size xsmall
  graph s'cc&pie-c'cc&pie
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

  title #1 text "Short-term Interest Rate", size small
  title #2 null
  graph s'cc&rs-c'cc&rs
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

  title #1 text "Nominal Exchange Rate", size small
  title #2 text "local unit per"+FO_currency, size xsmall 
  graph 100*s'HO_er/c'HO_er-100
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

--  title #1 text "Real Effective Exchange Rate", size small
--  title #2 text "trade weights,1997=100", size xsmall
--  graph 100*exp(s'cc&reer_t)/exp(c'cc&reer_t)-100
--  draw marking <depict axis bottom> at ehist
--  draw marking <depict axis left> at 0

--  title #1 text "Real Effective Exchange Rate", size small
--  title #2 text "import weights,1997=100", size xsmall
--  graph 100*exp(s'cc&reer_m)/exp(c'cc&reer_m)-100
--  draw marking <depict axis bottom> at ehist
--  draw marking <depict axis left> at 0

  title #1 text "Real Exchange Rate", size small
  title #2 text "+ve is a depreciation vs "+FO, size xsmall
  graph 100*exp(s'HO_lz/100)/exp(c'HO_lz/100)-100
---- THIS WORKS BUT THE THE EXP ABOVE IT   graph 100*s'HO_lz/c'HO_lz-100
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

---May 25, 2007
  title #1 text "Equilibrium Real Exchange Rate", size small
  title #2 text "+ve is a depreciation vs "+FO, size xsmall
--  graph 100*exp(s'HO_lz_eq/100)/exp(c'HO_lz_eq/100)-100
  graph s'HO_lz_eq - c'HO_lz_eq
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0



--  title #1 text "Foreign Activity", size small
--  title #2 text "export weights", size xsmall
--  graph s'cc&fact-c'cc&fact
--  draw marking <depict axis bottom> at ehist
--  draw marking <depict axis left> at 0

  title #1 text "Price of Oil", size small
  title #2 text FO_currency, size xsmall
  graph s'FO_poil, c'FO_poil
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

--  title #1 text "PGDP Inflation", size small
--  title #2 text "% q@ar", size xsmall
--  graph s'cc&pie_pgdp-c'cc&pie_pgdp
--  draw marking <depict axis bottom> at ehist
--  draw marking <depict axis left> at 0

 picture terminal
 picture <access append> file(lower(picname)+"graph.eps")

  if upper(shockname) eq "FROMFILE"
     page title #4 text string(cc)+": Graph "+tabnum+": "+shocktitle
  else
     page title #4 text string(cc)+": "+shockname, size medium
  end if
  page title #5 text "Residuals", size small

  title #1 text "Output Gap", size small
  title #2 null
  graph s'res&cc&gdp_gap-c'res&cc&gdp_gap
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

  title #1 text "Core Inflation", size small
  graph s'res&cc&piex-c'res&cc&piex
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

  title #1 text "Headline Inflation", size small
  graph s'res&cc&pie-c'res&cc&pie
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

--  title #1 text "PGDP Inflation", size small
--  graph s'res&cc&pie_pgdp-c'res&cc&pie_pgdp
--  draw marking <depict axis bottom> at ehist
--  draw marking <depict axis left> at 0

  title #1 text "Short-term Interest Rate", size small
  graph s'res&cc&rs-c'res&cc&rs
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

  title #1 text "Real Exchange Rate", size small
  graph s'res_HO_lz, c'res_HO_lz
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

  title #1 text "Real Price of Oil", size small
  graph s'res_FO_rel_poil_gap, c'res_FO_rel_poil_gap
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

  title #1 text "Potential Output", size small
  graph s'res&cc&lgdp_eq-c'res&cc&lgdp_eq
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

  title #1 text "Potential Output Growth", size small
  graph s'res&cc&growth-c'res&cc&growth
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

  title #1 text "Core Inflation Target", size small
  graph s'res&cc&pietarget-c'res&cc&pietarget
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

--  title #1 text "Equilibrium Interest Rate", size small
--  graph s'res&cc&rr_eq-c'res&cc&rr_eq
--  draw marking <depict axis bottom> at ehist
--  draw marking <depict axis left> at 0

  title #1 text "Equilibrium Real Exchange Rate", size small
  title #2 text "+ve is a depreciation vs "+FO, size xsmall
  graph s'res_HO_lz_eq, c'res_HO_lz_eq
  draw marking <depict axis bottom> at ehist
  draw marking <depict axis left> at 0

 picture terminal

end loop
close s,c

end procedure


























--**********************************************************************
--OLD $levelgraph BACKED UP JANUARY25

--procedure $levelgraph
--argument db,sdate,ehist,edate,varlist,picname

--try
--close all
--end try
--reset
--plot #1 color blue
--plot #2 color red
--plot #3 color black
--abort on
--show vertical
--length full
--ignore on
--over on
--deci auto
--object precision
--page frame off
--page divi rows 1, colu 1
--freq q
--
--exec "vlist={"+varlist+"}"
--open <acc r> db as c
--image date daily "<m>/<d>/<year>" 
--scalar work'dbname1: string=upper(ltrim(mirror(substring(mirror(filespec(c)),4,location(mirror(filespec(c)),"\"))),"\"))
--scalar work'dbdate1: string=datefmt(dbupdated(c))
--date sdate to edate
--
--deci 1
--devi graph postl
--tick label size xsmall
--legend size small
--legend division columns 3
--axis on
--
--picture <access over> file(picname+".eps")
--
--image date quarterly "<year>q<p>"
--page title #1 left text "Printed: "+today+" "+now, size xsmall
--page title #2 left text "Database: "+dbname1, size xsmall
--page title #2 right text "Created: "+dbdate1, size xsmall
--page title #3 text ""+forecast_round[1]+" Forecast Round", size medium
--graph
-- data vlist
-- draw marking <depict axis left> at 0.0
-- draw marking <depict axis bottom> at ehist
--end graph
--
--picture terminal
--close all
--
--end procedure
--**********************************************************************


--**********************************************************************
--OLD $graph BACKED UP JANUARY25
--procedure $graph
--argument s1,db2,sdate,ehist,edate,varlist,picname

--try
-- close all
--end try
--reset
--plot #1 color blue
--plot #2 color red
--plot #3 color black
--abort on
--show vertical
--length full
--ignore on
--over on
--deci auto
--object precision
--page divi rows 4, colu 2
--page frame off
--devi graph postp
--freq q
--
--exec "vlist={"+varlist+"}"
--open <acc r> s1 as s
--open <acc r> db2 as c
--
--image date daily "<m>/<d>/<year>" 
--scalar work'dbname1: string=upper(ltrim(mirror(substring(mirror(filespec(s)),4,location(mirror(filespec(s)),"\"))),"\"))
--scalar work'dbdate1: string=datefmt(dbupdated(s))
--scalar work'dbname2: string=upper(ltrim(mirror(substring(mirror(filespec(c)),4,location(mirror(filespec(c)),"\"))),"\"))
--scalar work'dbdate2: string=datefmt(dbupdated(c))
--
--date sdate to edate
--
--tick label size xsmall
--legend off
--axis on
--
--picture <access over> file(picname+".eps")
--
--image date quarterly "<year>q<p>"
--page title #1 left text "Printed: "+today+" "+now, size xsmall
--page title #2 left text "Database: "+dbname1, size xsmall
--page title #2 right text "Created: "+dbdate1, size xsmall
--page title #3 left text "Database: "+dbname2, size xsmall
--page title #3 right text "Created: "+dbdate2, size xsmall
--page title #4 text ""+forecast_round[1]+" Forecast Round", size medium
--page title #5 text "Deviation from baseline: "+dbname2+" - "+dbname1, size small
--loop for var in vlist
-- try
--  graph
--   title #1 text name(var), size small
--   data s'var-c'var
--   draw marking <depict axis bottom> at ehist
--   draw marking <depict axis left> at 0
--  end graph
-- otherwise
--  type errortext
-- end try
--end loop
--
--picture terminal
--close all
--
--end procedure
--**********************************************************************







--************************************************************************
procedure $parameters
argument con,picname,shockname

reset
length full
show vertical
pause off
abort on
ignore on
over on
object precision
channel reports picture
page frame off
image date daily "<m>/<d>/<year>" 
freq q
glue "_"
fill "..."

open <acc r> countrynames as cn
open <acc r> con as c

scalar work'dbname1: string=upper(ltrim(mirror(substring(mirror(filespec(c)),4,location(mirror(filespec(c)),"\"))),"\"))
scalar work'dbdate1: string=datefmt(dbupdated(c))
page division colu 1, rows 1

deci 4

devi graph postp
picture <access over> file(picname+"parameters.eps")
picture terminal
render points 7.4
render leftmargin 200

picture <access append> file(picname+"parameters.eps")
report
 title area length standard
 title #1 left points 7.4, text "Printed: "+today+" "+now
 title #2 right points 7.4, text "Shock database: "+dbname1
 title #3 right points 7.4, text "Created: "+dbdate1
 title #4 points 12, text shockname
 title #5 points 8, font f3, text "Parameters"

 <over on> countrylist = {HO, FO}
 loop for cc in countrylist
   exec("select "+name(cc)+" as "+quote+string(cc)+quote)
 end loop

 deci 4
 blank
 text "DOMESTIC MARKETS"
 blank
 text "The I-S Curve (BETA)"
 print value @stub&beta_ygaplag as                "  lagged output gap (YGAPLAG)"
 print value @stub&beta_ygapld as                 "  led output gap (YGAPLD)"
 print value @stub&beta_rrgap as                   "  lag of real interest rate gap (RRGAP)"

 FO_beta_zgap = ND
 print value @stub&beta_zgap as "  lagged real exchange rate gap (ZGAP)"


 FO_beta_FO_gdp_gap = ND
 print value @stub&beta_FO_gdp_gap as "  foriegn activity variable (foreign YGAP)"

 blank

 text "Headline Inflation - CPI (ALPHA)"
 print value @stub&alpha_pie as "  led headline CPI inflation (PIE)"
 print value @stub&alpha_ygap as "  lag of the output gap (YGAP)"
 print value @stub&alpha_1 as "  change in the real oil price (PIE_RPOIL)"
 print value @stub&alpha_2 as "  lagged change in the real oil price (PIE_RPOIL)"
 FO_alpha_zgap = ND
 print value @stub&alpha_zgap as "  change in te real exchange (ZGAP)"
 blank

 text "Core Inflation - CPI (ALPHA_X)"
 print value @stub&alpha_pie_x as "  led headline CPI inflation (PIEX)"
 print value @stub&alpha_ygap_x as "  lag of the output gap (YGAPX)"
 print value @stub&alpha_rpoil_x as "  lagged diff. between y-o-y headline and core inflation (PIE4-PIE4X)"
 FO_alpha_zgap_x = ND
-- text "The Modified UIP Condition (DELTA)"
 print value @stub&alpha_zgap_x as "  change in te real exchange (ZGAP)"
 blank


 text "The Monetary Policy Rule (GAMMA)" 
 print value @stub&gamma_rslag as "  lagged interest rate (RSLAG)"
 print value @stub&gamma_pie as "  1-yr ahead headline & core CPI y-o-y inflation (PIE4&PIE4X)"
 print value @stub&gamma_ygap as "  output gap (YGAP)"
 blank

-- Added the effect of oil prices on potential output
 text "The Effect of Oil on Potential Output (NU)" 
 print value @stub&nu_rpoil as "  oil impact on potential output (NU)"
 blank


 FO_delta_zld = ND
 text "The Modified UIP Condition (DELTA)"
 print value @stub&delta_zld as "  led bilateral "+FO_currency+" exchange rate (ZLD)"
 blank
 line
 blank





text "FOREIGN MARKETS"
 blank
 text "The Real Price of Oil (THETA)"
 print value FO_theta_1 as "  lagged real oil price gap (1)"
 blank
 line
 blank

 text "STOCHASTIC PROCESSES"
 blank

 lambda_FO_lz_eq = ND
 text "Persistence Parameters on Variables (LAMBDA)"      
 print value lambda&@stub&growth as "  potential output growth (GROWTH)"
 print value lambda&@stub&rr_eq as "  equilibrium interest rate (RR_EQ)"
 print value lambda&@stub&pietarget as "  core inflation target (PIE_TARGET)"
 print value lambda&@stub&lz_eq as "  equilibrium real exchange rate (LZ_EQ)"
 blank
 line
 blank














end report
picture terminal

close c

end procedure


















